"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isPropsAssignment = exports.isHandledAssignment = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const isHandledAssignment = (path, {
  left,
  right,
  property
}) => {
  if (!t.isMemberExpression(left) || !t.isIdentifier(property, {
    name: 'handledProps'
  })) return false;
  if (!t.isArrayExpression(right)) throw path.buildCodeFrameError('`handledProps` must be an array');
  return true;
};

exports.isHandledAssignment = isHandledAssignment;

const isPropsAssignment = (path, {
  left,
  right,
  property
}) => {
  if (!t.isMemberExpression(left)) return false;
  if (!t.isIdentifier(property, {
    name: 'defaultProps'
  }) && !t.isIdentifier(property, {
    name: 'propTypes'
  })) return false;
  if (!t.isObjectExpression(right)) throw path.buildCodeFrameError('`defaultProps` and `propTypes` must be an object');
  return true;
};

exports.isPropsAssignment = isPropsAssignment;