"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class Store {
  constructor() {
    _defineProperty(this, "entries", {});

    _defineProperty(this, "hasImport", false);

    _defineProperty(this, "addProps", (name, newProps) => {
      this.entries[name].props = _lodash.default.union(this.entries[name].props, newProps);
    });

    _defineProperty(this, "createEntry", (name, path) => {
      this.entries[name] = {
        path,
        props: []
      };
    });

    _defineProperty(this, "getEntries", () => _lodash.default.map(this.entries, ({
      path,
      props
    }, identifier) => ({
      identifier,
      path,
      props
    })));

    _defineProperty(this, "hasEntry", name => _lodash.default.has(this.entries, name));
  }

}

exports.default = Store;