"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

var _lodash = _interopRequireDefault(require("lodash"));

var _getVariableDeclarator = _interopRequireDefault(require("./getVariableDeclarator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const getPositionIdentifier = ({
  node
}) => _lodash.default.get(node, 'id.name', `${node.start}:${node.end}`);

const getFunctionIdentifier = path => {
  if (t.isFunctionDeclaration(path)) return getPositionIdentifier(path);

  if (t.isArrowFunctionExpression(path) || t.isFunctionExpression(path)) {
    return getPositionIdentifier((0, _getVariableDeclarator.default)(path));
  }

  throw path.buildCodeFrameError('`path` is unsupported Function definition');
};

const getEntryIdentifier = path => {
  if (t.isClass(path)) return getPositionIdentifier(path);
  if (t.isFunction(path)) return getFunctionIdentifier(path);
  throw path.buildCodeFrameError('`path` must be Class or Function definition');
};

var _default = getEntryIdentifier;
exports.default = _default;