"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isValidProperty = exports.isValidExpression = exports.isStaticProperty = exports.isObjectValue = exports.isObjectProperty = exports.isArrayValue = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

const isArrayValue = path => t.isArrayExpression(path);

exports.isArrayValue = isArrayValue;

const isObjectProperty = path => t.isObjectProperty(path);

exports.isObjectProperty = isObjectProperty;

const isObjectValue = path => t.isObjectExpression(path);

exports.isObjectValue = isObjectValue;

const isStaticProperty = ({
  node
}) => !!node.static;

exports.isStaticProperty = isStaticProperty;

const isValidExpression = ({
  node: {
    left = {}
  }
}, names) => {
  const property = left.property;
  const name = property.name;
  return t.isMemberExpression(left) && t.isIdentifier(property) && _lodash.default.includes(names, name);
};

exports.isValidExpression = isValidExpression;

const isValidProperty = (path, names) => {
  const key = path.node.key;
  const name = key.name;
  return t.isIdentifier(key) && _lodash.default.includes(names, name);
};

exports.isValidProperty = isValidProperty;